#ifdef __APPLE__
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

#define WINDOW_WIDTH    1000
#define WINDOW_HEIGHT   1000

#define LATTICE_WIDTH   300
#define LATTICE_HEIGHT  300

#define WIDTH_OF_LATTICE    LATTICE_WIDTH + 1
#define HEIGHT_OF_LATTICE   2*LATTICE_HEIGHT + 1

short lattice[HEIGHT_OF_LATTICE][WIDTH_OF_LATTICE];
short old_lattice[HEIGHT_OF_LATTICE][WIDTH_OF_LATTICE];
int mouse_x, mouse_y;
unsigned int next_rand;

int flip_coin()
{
    int r = random_int();
    return r % 2;
}

int random_int()
{
    next_rand = next_rand * 1103515245 + 12345;
    return (unsigned int) (next_rand / 65536);
}

void rule(short old[][WIDTH_OF_LATTICE], short new[][WIDTH_OF_LATTICE],
	  short s_ne, int x_ne, int y_ne,
	  short s_e, int x_e, int y_e,
	  short s_se, int x_se, int y_se,
	  short s_sw, int x_sw, int y_sw,
	  short s_w, int x_w, int y_w, short s_nw, int x_nw, int y_nw)
{
    int ne = s_ne * old[x_ne][y_ne];
    int e = s_e * old[x_e][y_e];
    int se = s_se * old[x_se][y_se];
    int sw = s_sw * old[x_sw][y_sw];
    int w = s_w * old[x_w][y_w];
    int nw = s_nw * old[x_nw][y_nw];

    if (ne == 1 && e == 0 && se == 1 && sw == 0 && w == 1 && nw == 0) {
	new[x_ne][y_ne] = 0;
	new[x_e][y_e] = 1;
	new[x_se][y_se] = 0;
	new[x_sw][y_sw] = 1;
	new[x_w][y_w] = 0;
	new[x_nw][y_nw] = 1;
    }
    /**/
    else if (ne == 0 && e == 1 && se == 0 && sw == 1 && w == 0 && nw == 1) {
	new[x_ne][y_ne] = 1;
	new[x_e][y_e] = 0;
	new[x_se][y_se] = 1;
	new[x_sw][y_sw] = 0;
	new[x_w][y_w] = 1;
	new[x_nw][y_nw] = 0;
    }
    /**/
    else if (ne == 0 && e == 1 && se == 0 && sw == 0 && w == 1 && nw == 0) {
	if (flip_coin()) {
	    new[x_ne][y_ne] = 1;
	    new[x_e][y_e] = 0;
	    new[x_se][y_se] = 0;
	    new[x_sw][y_sw] = 0;
	    new[x_w][y_w] = 0;
	    new[x_nw][y_nw] = 1;
	} else {
	    new[x_ne][y_ne] = 0;
	    new[x_e][y_e] = 0;
	    new[x_se][y_se] = 1;
	    new[x_sw][y_sw] = 1;
	    new[x_w][y_w] = 0;
	    new[x_nw][y_nw] = 0;
	}
    }
    /**/
    else if (ne == 1 && e == 0 && se == 0 && sw == 0 && w == 0 && nw == 1) {
	if (flip_coin()) {
	    new[x_ne][y_ne] = 0;
	    new[x_e][y_e] = 1;
	    new[x_se][y_se] = 0;
	    new[x_sw][y_sw] = 0;
	    new[x_w][y_w] = 1;
	    new[x_nw][y_nw] = 0;
	} else {
	    new[x_ne][y_ne] = 0;
	    new[x_e][y_e] = 0;
	    new[x_se][y_se] = 1;
	    new[x_sw][y_sw] = 1;
	    new[x_w][y_w] = 0;
	    new[x_nw][y_nw] = 0;
	}
    } else if (ne == 0 && e == 0 && se == 1 &&
	       sw == 1 && w == 0 && nw == 0) {
	new[x_ne][y_ne] = 0;
	new[x_e][y_e] = 1;
	new[x_se][y_se] = 0;
	new[x_sw][y_sw] = 0;
	new[x_w][y_w] = 1;
	new[x_nw][y_nw] = 0;
    }
    /**/
    else if (ne == 0 && e == 1 && se == 0 && sw == 0 && w == 1 && nw == 1) {
	new[x_ne][y_ne] = 0;
	new[x_e][y_e] = 0;
	new[x_se][y_se] = 1;
	new[x_sw][y_sw] = 1;
	new[x_w][y_w] = 0;
	new[x_nw][y_nw] = 1;
    }
    /**/
    else if (ne == 0 && e == 0 && se == 1 && sw == 1 && w == 0 && nw == 1) {
	new[x_ne][y_ne] = 0;
	new[x_e][y_e] = 1;
	new[x_se][y_se] = 0;
	new[x_sw][y_sw] = 0;
	new[x_w][y_w] = 1;
	new[x_nw][y_nw] = 1;
    }
    /**/
    else if (ne == 1 && e == 0 && se == 1 && sw == 1 && w == 0 && nw == 1) {
	if (flip_coin()) {
	    new[x_ne][y_ne] = 0;
	    new[x_e][y_e] = 1;
	    new[x_se][y_se] = 1;
	    new[x_sw][y_sw] = 1;
	    new[x_w][y_w] = 1;
	    new[x_nw][y_nw] = 0;
	} else {
	    new[x_ne][y_ne] = 1;
	    new[x_e][y_e] = 1;
	    new[x_se][y_se] = 0;
	    new[x_sw][y_sw] = 0;
	    new[x_w][y_w] = 1;
	    new[x_nw][y_nw] = 1;
	}
    }
    /**/
    else if (ne == 1 && e == 1 && se == 0 && sw == 0 && w == 1 && nw == 1) {
	new[x_ne][y_ne] = 1;
	new[x_e][y_e] = 0;
	new[x_se][y_se] = 1;
	new[x_sw][y_sw] = 1;
	new[x_w][y_w] = 0;
	new[x_nw][y_nw] = 1;
    } else if (ne == 0 && e == 1 && se == 1 &&
	       sw == 1 && w == 1 && nw == 0) {
	new[x_ne][y_ne] = 1;
	new[x_e][y_e] = 0;
	new[x_se][y_se] = 1;
	new[x_sw][y_sw] = 1;
	new[x_w][y_w] = 0;
	new[x_nw][y_nw] = 1;
    } else if (ne == 1 && e == 1 && se == 1 &&
	       sw == 1 && w == 1 && nw == 1) {
	new[x_ne][y_ne] = 0;
	new[x_e][y_e] = 0;
	new[x_se][y_se] = 0;
	new[x_sw][y_sw] = 0;
	new[x_w][y_w] = 0;
	new[x_nw][y_nw] = 0;
    }
    /**/
    else {
	if (ne == 1 || e == 1 || se == 1 || sw == 1 || w == 1 || nw == 1) {
	    if (ne == 1 && x_ne < HEIGHT_OF_LATTICE - 3 && y_ne > 0) {
		new[x_ne + 2][y_ne - 1] = 1;
	    }
	    if (e == 1 && y_e > 0) {
		new[x_e][y_e - 1] = 1;
	    }
	    if (se == 1 && x_se > 0 && y_se > 0) {
		new[x_se - 1][y_se - 1] = 1;
	    }

	    if (sw == 1 && x_sw > 1 && y_sw < WIDTH_OF_LATTICE - 1) {
		new[x_sw - 2][y_sw + 1] = 1;
	    }
	    if (w == 1 && y_w < WIDTH_OF_LATTICE - 1) {
		new[x_sw][y_sw + 1] = 1;
	    }
	    if (nw == 1 && x_nw < HEIGHT_OF_LATTICE - 3
		&& y_nw < WIDTH_OF_LATTICE - 1) {
		new[x_sw + 2][y_ne + 1] = 1;
	    }
	} else if (ne == -1 || e == -1 || se == -1 ||
		   sw == -1 || w == -1 || nw == -1) {
	    if (ne == -1 && x_ne > 1 && y_ne < WIDTH_OF_LATTICE - 1) {
		new[x_ne - 1][y_ne] = 1;
	    }
	    if (e == -1 && y_e < WIDTH_OF_LATTICE - 1) {
		new[x_ne][y_ne + 1] = 1;
	    }
	    if (se == -1 && x_se < HEIGHT_OF_LATTICE - 2
		&& y_se < WIDTH_OF_LATTICE - 1) {
		new[x_ne + 1][y_ne + 1] = 1;
	    }

	    if (nw == -1 && x_nw < HEIGHT_OF_LATTICE - 2
		&& y_nw < WIDTH_OF_LATTICE - 1) {
		new[x_ne + 2][y_ne + 1];
	    }
	    if (w == -1 && y_w > 0) {
		new[x_ne][y_ne - 1];
	    }
	    if (sw == -1 && x_sw < HEIGHT_OF_LATTICE - 1) {
		new[x_ne + 1][y_ne];
	    }
	}
    }
 /**/}

void next()
{
    int i, j;
    int k = 0;

    for (i = 0; i < HEIGHT_OF_LATTICE; i += 1) {
	for (j = 0; j <= WIDTH_OF_LATTICE; j += 2) {
	    if (i != 0 && j != 0 &&
		i < HEIGHT_OF_LATTICE - 1 && j < WIDTH_OF_LATTICE - 1) {
		rule(old_lattice, lattice, 1, i - 1, j,	//NE
		     1, i, j,	//E
		     1, i + 1, j,	//SE
		     1, i + 1, j - 1,	//SW
		     1, i, j - 1,	//W
		     1, i - 1, j - 1);	//NW
	    } else if (i == 0)	//First Row
	    {
		if (j == 0)	//Top left corner
		{
		    rule(old_lattice, lattice, 0, i, j,	//NE
			 1, i, j,	//E
			 1, i + 1, j,	//SE
			 0, i, j,	//SW
			 1, i, j,	//W
			 1, i + 1, j);	//NW
		} else if (j == WIDTH_OF_LATTICE)	//Top right corner
		{
		    rule(old_lattice, lattice, 1, i + 1, j - 1,	//NE
			 1, i, j - 1,	//E
			 0, i, j - 1,	//SE
			 1, i + 1, j - 1,	//SW
			 1, i, j - 1,	//W
			 0, i, j - 1);	//NW
		} else		//First row
		{
		    rule(old_lattice, lattice, 1, i + 1, j - 1,	//NE
			 1, i, j,	//E
			 1, i + 1, j,	//SE
			 1, i + 1, j - 1,	//SW
			 1, i, j - 1,	//W
			 1, i + 1, j);	//NW
		}
	    }

		/*******************************************************/
	    else if (i == HEIGHT_OF_LATTICE - 1)	//Last Row
	    {
		if (j == 0)	//Lower left corner
		{
		    rule(old_lattice, lattice, 1, i - 1, j,	//NE
			 1, i, j,	//E
			 0, i, j,	//SE
			 1, i - 1, j,	//SW
			 1, i, j,	//W
			 0, i, j);	//NW
		} else if (j == WIDTH_OF_LATTICE)	//Lower right corner
		{
		    rule(old_lattice, lattice, 0, i, j,	//NE
			 1, i, j - 1,	//E
			 1, i - 1, j - 1,	//SE
			 0, i, j,	//SW
			 1, i, j - 1,	//W
			 1, i - 1, j - 1);	//NW
		} else		//last row
		{
		    rule(old_lattice, lattice, 1, i - 1, j,	//NE
			 1, i, j,	//E
			 1, i - 1, j - 1,	//SE
			 1, i - 1, j,	//SW
			 1, i, j - 1,	//W
			 1, i - 1, j - 1);	//NW
		}
	    }

		/*******************************************************/

	    else if (j == 0)	//left most column
	    {
		rule(old_lattice, lattice, 1, i - 1, j,	//NE
		     1, i, j,	//E
		     1, i + 1, j,	//SE
		     1, i - 1, j,	//SW
		     1, i, j,	//W
		     1, i + 1, j);	//NW
	    }

		/*******************************************************/
	    else if (j == WIDTH_OF_LATTICE)	//right most column
	    {
		rule(old_lattice, lattice, 1, i + 1, j - 1,	//NE
		     1, i, j - 1,	//E
		     1, i - 1, j - 1,	//SE
		     1, i + 1, j - 1,	//SW
		     1, i, j - 1,	//W
		     1, i - 1, j - 1);	//NW
	    }
	}
    }
    for (i = 0; i < HEIGHT_OF_LATTICE; i++) {
	for (j = 0; j < WIDTH_OF_LATTICE; j++) {
	    if (lattice[i][j] == 1) {
		k++;
	    }
	    old_lattice[i][j] = lattice[i][j];
	    lattice[i][j] = 0;
	}
    }
    printf("k = %d\n", k);

}

void display()
{
    int i, j, out;

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glLoadIdentity();
    glColor3f(1.0, 1.0, 1.0);
    next();

    /*
       for(i = 0; i < 90; i++) {
       printf("%d ", lattice[i][i]);
       }
       printf("\n");
     */

    glBegin(GL_POINTS);
    for (i = 0; i < HEIGHT_OF_LATTICE; i += 1) {
	for (j = 0; j < WIDTH_OF_LATTICE; j += 1) {
	    out = old_lattice[i][j];
	    if (out == 0) {
		glColor3f(0.1, 0.0, 0.0);
	    } else {
		glColor3f(0.2, .2, 0.9);
	    }
	    glVertex3f(j * 0.6 + WINDOW_WIDTH / 4,
		       i * 0.6 + WINDOW_HEIGHT / 4, 0.0);
	}
    }
    glEnd();
    if (mouse_x != 0 && mouse_y != 0) {
	/*
	   for(i = 0; i < 50; i++)
	   {
	   for(j = 0; j < 50; j++)
	   {
	   old_lattice[(WINDOW_HEIGHT - mouse_y)%LATTICE_HEIGHT + i][(WINDOW_WIDTH - mouse_x)%LATTICE_WIDTH + j] = 0;
	   lattice[(WINDOW_HEIGHT - mouse_y)%LATTICE_HEIGHT + i][(WINDOW_WIDTH - mouse_x)%LATTICE_WIDTH + j] = 0;

	   //printf("mouseX: %d, mouseY: %d\n", mouse_x, mouse_y);
	   }
	   }
	 */
	mouse_x = 0;
	mouse_y = 0;

	for (i = 0; i < 50; i++) {
	    for (j = 0; j < LATTICE_WIDTH / 2; j++) {
		old_lattice[i + LATTICE_HEIGHT / 2][j +
						    LATTICE_WIDTH / 4] = 0;
		lattice[i + LATTICE_HEIGHT / 2][j + LATTICE_WIDTH / 4] = 0;
	    }
	}
    }


    //drawFluid( );
    glutSwapBuffers();
}

void idle()
{
    glutPostRedisplay();
}

void init()
{
    int i, j, k, r;
    next_rand = 0;

    /*
       for(i = 0; i < HEIGHT_OF_LATTICE; i++)
       {
       for(j = 0; j < WIDTH_OF_LATTICE; j++)
       {
       r = random_int( );
       if(r%3 == 0)
       {
       //printf("djsa %d\n", r);
       old_lattice[i][j] =  1;
       lattice[i][j] = old_lattice[i][j];
       }
       else
       {
       old_lattice[i][j] =  0;
       lattice[i][j] = old_lattice[i][j];
       }
       //printf("%d\n", lattice[i][j]);
       }
       }
     */
    /*
       for(i = 0; i < HEIGHT_OF_LATTICE/5; i++)
       {
       for(j = 0; j < WIDTH_OF_LATTICE/5; j++)
       {
       old_lattice[i][j] = 1;
       lattice[i][j] = 1;
       }
       }
     */
    /*
       for(k = 0; k < 2; k++)
       {
       for(i = 0; i < LATTICE_HEIGHT/2; i++)
       {
       for(j = 0; j < LATTICE_WIDTH/2; j++)
       {
       old_lattice[k*i][k*j] = 0;
       lattice[k*i][k*j] = 0;
       //old_lattice[HEIGHT_OF_LATTICE - j*k][WIDTH_OF_LATTICE - j*k] = 1;
       //lattice[HEIGHT_OF_LATTICE - j*k][WIDTH_OF_LATTICE - j*k] = 1;
       }
       }
       }
     */

    for (i = 0; i < HEIGHT_OF_LATTICE; i++) {
	for (j = 0; j < WIDTH_OF_LATTICE; j++) {
	    old_lattice[i][j] = 0;
	    lattice[i][j] = 0;
	}
    }

    for (i = 0; i < HEIGHT_OF_LATTICE / 2; i++) {
	for (j = 0; j < WIDTH_OF_LATTICE / 2; j++) {
	    old_lattice[i][j] = 1;
	    lattice[i][j] = 1;
	}
    }

    glClearColor(0.0, 0.0, 0.0, 0.0);

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(0.0, WINDOW_WIDTH, 0.0, WINDOW_HEIGHT, -20.0, 20.0);

    glMatrixMode(GL_MODELVIEW);

    glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
    glShadeModel(GL_SMOOTH);
}

void mouse(int button, int state, int x, int y)
{
    mouse_x = x;
    mouse_y = y;
}

int main(int argc, char **argv)
{
    mouse_x = 0;
    mouse_y = 0;

    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
    glutInitWindowSize(WINDOW_WIDTH, WINDOW_HEIGHT);
    glutCreateWindow("fhp");
    glEnable(GL_DEPTH_TEST);
    init();
    glutMouseFunc(mouse);
    glutDisplayFunc(display);
    glutIdleFunc(idle);
    glutMainLoop();
    return 0;
}
